#region Copyright

/*
 * Copyright 2005-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

#endregion

using System;
using System.Diagnostics;
using System.Drawing;
using System.IO;

namespace Seasar.Dxo.Converter.Impl
{
    /// <summary>
    /// IuWFNgImageɕϊRo[^
    /// </summary>
    public class ImageConverter : AbstractPropertyConverter
    {
        /// <summary>
        /// IuWFNg̃vpeBCӂ̌^ɕϊ܂
        /// (ۃ\bh͔hNXŕKI[oCh܂)
        /// </summary>
        /// <param name="source">ϊ̃IuWFNg</param>
        /// <param name="dest">ϊ̃IuWFNg</param>
        /// <param name="expectType">ϊ̃IuWFNgɊ҂Ă^</param>
        /// <returns>bool ϊꍇɂtrue</returns>
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            Debug.Assert(typeof (Image).IsAssignableFrom(expectType)
                         , String.Format(DxoMessages.EDXO1002, "expectType", "Image"));
            //            Debug.Assert(typeof(Image).IsAssignableFrom(expectType)
//                         , "expectTypeImageƌ݊ȂĂ͂ȂȂ");

            if (source is Image)
            {
                dest = (source as Image).Clone();
                return true;
            }
            else if (source is string)
            {
                string resource = source as string;
                if (File.Exists(resource))
                {
                    dest = Image.FromFile(resource);
                    return true;
                }
            }
            return false;
        }
    }
}