#region Copyright
/*
 * Copyright 2005-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;

namespace Seasar.Quill.Attrs
{
    /// <summary>
    /// Aspectw肷鑮NX
    /// </summary>
    /// <remarks>
    /// NXEC^[tF[XE\bhɐݒ肷邱ƂłB
    /// (ݒ肷邱Ƃł)
    /// </remarks>
    [AttributeUsage(AttributeTargets.Interface |
       AttributeTargets.Class | AttributeTargets.Method, AllowMultiple = true)]
    public class AspectAttribute : Attribute
    {
        /// <summary>
        /// InterceptorType
        /// </summary>
        protected Type interceptorType;

        /// <summary>
        /// S2ContainerɂR|[lg
        /// </summary>
        protected string componentName;

        /// <summary>
        /// AspectKp鏇(قɓKp)
        /// </summary>
        protected int ordinal = 0;

        /// <summary>
        /// InterceptorTypew肵AspectAttributeRXgN^
        /// </summary>
        /// <param name="interceptorType">InterceptorType</param>
        public AspectAttribute(Type interceptorType)
        {
            // InterceptorTypeݒ肷
            this.interceptorType = interceptorType;
        }

        /// <summary>
        /// InterceptorTypew肵AspectAttributeRXgN^
        /// </summary>
        /// <param name="interceptorType">InterceptorType</param>
        /// <param name="ordinal">AspectKp鏇</param>
        public AspectAttribute(Type interceptorType, int ordinal)
        {
            // InterceptorTypeݒ肷
            this.interceptorType = interceptorType;

            // AspectKp鏇Ԃݒ肷
            this.ordinal = ordinal;
        }

        /// <summary>
        /// InterceptorS2ContainerɂR|[lgw肵
        /// AspectAttributeRXgN^
        /// </summary>
        /// <param name="componentName">S2ContainerɂR|[lg</param>
        public AspectAttribute(string componentName)
        {
            // S2ContainerɂR|[lgݒ肷
            this.componentName = componentName;
        }

        /// <summary>
        /// InterceptorS2ContainerɂR|[lgw肵
        /// AspectAttributeRXgN^
        /// </summary>
        /// <param name="componentName">S2ContainerɂR|[lg</param>
        /// <param name="ordinal">AspectKp鏇</param>
        public AspectAttribute(string componentName, int ordinal)
        {
            // S2ContainerɂR|[lgݒ肷
            this.componentName = componentName;

            // AspectKp鏇Ԃݒ肷
            this.ordinal = ordinal;
        }

        /// <summary>
        /// InterceptorType擾
        /// </summary>
        /// <value>InterceptorType</value>
        public Type InterceptorType
        {
            get { return interceptorType; }
        }

        /// <summary>
        /// S2ContainerɂR|[lg擾
        /// </summary>
        /// <value>S2ContainerɂR|[lg</value>
        public string ComponentName
        {
            get { return componentName; }
        }

        /// <summary>
        /// AspectKp鏇Ԃ擾
        /// (قɓKp)
        /// </summary>
        /// <value>AspectKp鏇(قɓKp)</value>
        public int Ordinal
        {
            get { return ordinal; }
        }
    }
}
