#region Copyright
/*
 * Copyright 2005-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System.Collections.Generic;
using System;

namespace Seasar.Framework.Container.AutoRegister
{
    /// <summary>
    /// o^p̒ۃNXłB
    /// </summary>
	public abstract class AbstractAutoRegister
	{
        private IS2Container container;
        private IList<ClassPattern> classPatterns = new List<ClassPattern>();
        private IList<ClassPattern> ignoreClassPatterns = new List<ClassPattern>();

        /// <summary>
        /// Rei擾Eݒ肵܂B
        /// </summary>
        public IS2Container Container
        {
            set { container = value; }
            get { return container; }
        }

        /// <summary>
        /// ǉĂ ClassPattern ̐擾܂B
        /// </summary>
        public int ClassPatternSize
        {
            get { return classPatterns.Count; }
        }

        /// <summary>
        /// ClassPattern擾܂B
        /// </summary>
        /// <param name="index">擾ClassPatterñCfbNX</param>
        /// <returns>ClassPattern</returns>
        public ClassPattern GetClassPattern(int index)
        {
            return (ClassPattern)classPatterns[index];
        }

        /// <summary>
        /// o^œKp ClassPattern ǉ܂B
        /// </summary>
        /// <param name="namespaceName">OԖ</param>
        /// <param name="shortClassNames">NX̃p^[</param>
        public void AddClassPattern(string namespaceName, string shortClassNames)
        {
            AddClassPattern(new ClassPattern(namespaceName, shortClassNames));
        }

        /// <summary>
        /// o^œKp ClassPattern ǉ܂B
        /// </summary>
        /// <param name="classPattern">ClassPattern</param>
        public void AddClassPattern(ClassPattern classPattern)
        {
            classPatterns.Add(classPattern);
        }

        /// <summary>
        /// o^Ȃ ClassPattern ǉ܂B
        /// </summary>
        /// <param name="namespaceName">OԖ</param>
        /// <param name="shortClassNames">NX̃p^[</param>
        public void AddIgnoreClassPattern(string namespaceName, string shortClassNames)
        {
            AddIgnoreClassPattern(new ClassPattern(namespaceName, shortClassNames));
        }

        /// <summary>
        /// o^Ȃ ClassPattern ǉ܂B
        /// </summary>
        /// <param name="classPattern">ClassPattern</param>
        public void AddIgnoreClassPattern(ClassPattern classPattern)
        {
            ignoreClassPatterns.Add(classPattern);
        }

        /// <summary>
        /// o^s܂B
        /// </summary>
        /// <remarks>
        /// ɂ鏉\bh̎w肪łȂ̂JavałƂ͈قȂ
        /// ̃\bhdicont@Cŏ\bhƂČĂяoKv܂B
        /// </remarks>
        public abstract void RegisterAll();

        /// <summary>
        /// 邩ǂԂ܂B
        /// </summary>
        /// <param name="type">Type</param>
        /// <returns>邩ǂ</returns>
        protected bool IsIgnore(Type type)
        {
            if (ignoreClassPatterns.Count == 0)
            {
                return false;
            }

            for (int i = 0; i < ignoreClassPatterns.Count; ++i)
            {
                ClassPattern cp = ignoreClassPatterns[i];

                if (!cp.IsAppliedNamespaceName(type.Namespace))
                {
                    continue;
                }

                if (cp.IsAppliedShortClassName(type.Name))
                {
                    return true;
                }
            }

            return false;
        }
    }
}
